#include "../la_5.h"

extern LA MAIN;
extern struct _tnsMain *T;


int laget_InstanceModified(void* instance);
void laget_TimeString(laTimeInfo *ti, char *result, char** resultdirect);

void laui_DefaultPropDetails(laUiList *uil, laPropPack *This, laPropPack *Extra, laColumn *UNUSED, int context){
    laColumn *c;
    laUiItem *b;
    c = laFirstColumn(uil);
    laSafeString* s=0;

    if(Extra&&Extra->EndInstance){ //button
        laGeneralUiExtraData* ex=Extra->EndInstance;
        laUiItem* ui=ex->ui;
        if(This&&This->LastPs&&This->EndInstance){
            laProp* p=This->LastPs->p; laPropContainer* pc=p->Container; void* inst=This->LastPs->UseInstance; 
            char FullPath[256]={0}; la_GetPropPackFullPath(This, FullPath);
            strSafePrint(&s,"%s", FullPath); if(ui->ExtraInstructions){ strSafePrint(&s,"(%s)", ui->ExtraInstructions->Ptr); }
            laShowLabel(uil,c,p->Description,0,0);
            laShowLabel(uil,c,s->Ptr,0,0)->Flags|=LA_TEXT_MONO|LA_UI_FLAGS_DISABLED;
        }else{
            laShowLabel(uil,c,ui->AT->Description,0,0);
            strSafePrint(&s,"%s", ui->AT->Identifier); if(ui->ExtraInstructions){ strSafePrint(&s,"(%s)", ui->ExtraInstructions->Ptr); }
            laShowLabel(uil,c,s->Ptr,0,0)->Flags|=LA_TEXT_MONO|LA_UI_FLAGS_DISABLED;
        }
    }else{
        if(!This || !This->LastPs){ laShowLabel(uil,c,"Can't access property details.",0,0); return; }

        char FullPath[256]={0}; la_GetPropPackFullPath(This, FullPath);
        laProp* p=This->LastPs->p; laPropContainer* pc=p->Container; void* inst=This->LastPs->UseInstance;

        laShowLabel(uil,c,p->Description,0,0);
        if(p->PropertyType==(LA_PROP_ENUM)||(LA_PROP_ARRAY|LA_PROP_ENUM)){
            laEnumItem* ei=laGetEnumArrayIndexed(This,This->LastIndex);
            if(ei){ strSafeSet(&s,0);strSafePrint(&s,"Current: %s", ei->Description);laShowLabel(uil,c,s->Ptr,0,0)->Flags|=LA_UI_FLAGS_HIGHLIGHT; }
        }
        laShowLabel(uil,c,FullPath,0,0)->Flags|=LA_TEXT_MONO|LA_UI_FLAGS_DISABLED;

        if(inst && !pc->OtherAlloc){
            laShowSeparator(uil,c); strSafeSet(&s,0); strSafePrint(&s,"[ %s ]", pc->Name?pc->Name:pc->Identifier, inst);
            int Level=0; laMemNodeHyper* m=memGetHead(inst,&Level);

            laListHandle* users=memGetUserList(inst);
            if(users){ strSafePrint(&s," %d Users", lstCountElements(users)); }
            laShowLabel(uil,c,s->Ptr,0,0)->Flags|=LA_TEXT_MONO;

            if(Level==2){
                strSafeSet(&s,0);strSafePrint(&s, m->NUID.String);
                if(laget_InstanceModified(inst)){ strSafePrint(&s, " 🌑 Modified"); }else{ strSafePrint(&s, " Clean"); }
                laShowLabel(uil,c,s->Ptr,0,0)->Flags|=LA_TEXT_MONO;
                laget_TimeString(&m->TimeCreated, FullPath, 0); 
                strSafeSet(&s,0); strSafePrint(&s, "Created at %s", FullPath);
                laShowLabel(uil,c,s->Ptr,0,0)->Flags|=LA_TEXT_MONO;
            }

            if(m){
                if(Level==2){
                    laShowSeparator(uil,c);
                    if(m->FromFile){
                        //strSafeSet(&s,0); strSafePrint(&s,"File:\n%s", m->FromFile->BaseName);
                        //laShowLabel(uil,c,s->Ptr,0,0);
                        char safepath[256]; strEscapePath(safepath, m->FromFile->BaseName->Ptr);
                        strSafeSet(&s,0); strSafePrint(&s,"la.managed_udfs@basename=%s.__self", safepath);
                        laShowItemFull(uil,c,0,s->Ptr,0,0,laui_ManagedUDFItem,0)->Flags|=LA_UI_FLAGS_NO_GAP|LA_UI_FLAGS_NO_DECAL;
                    }else{
                        laShowLabel(uil,c,"<Not saved yet>",0,0)->Flags|=LA_UI_FLAGS_DISABLED;
                    }
                }
            }
            
        }
    }
    strSafeDestroy(&s);
}

void laui_DefaultPropUiDefine(laUiList *uil, laPropPack *This, laPropPack *OperatorProps, laColumn *UNUSED, int context){
    laColumn *c;
    laProp *p, *gp;

    if (OperatorProps && OperatorProps->LastPs){
        c = laFirstColumn(uil);

        gp = OperatorProps->LastPs->p;
        for (p = gp->SubProp->Props.pFirst; p; p = p->Item.pNext){
            laShowItem(uil, c, OperatorProps, p->Identifier);
        }
    }

    if (!This || !This->LastPs) return;

    c = laFirstColumn(uil);

    gp = This->LastPs->p;
    for (p = gp->SubProp->Props.pFirst; p; p = p->Item.pNext){
        //la_ShowGeneralPropItem(uil, c, This, gp, p, 0, 0, 0);
        laShowItem(uil, c, This, p->Identifier);
    }
}
void laui_StringPropUiDefine(laUiList *uil, laPropPack *This, laPropPack *Extra, laColumn *UNUSED, int context){
    laColumn *c;
    laProp *p, *gp;

    if (!This || !This->LastPs) return;
    c = laFirstColumn(uil);

    gp = This->LastPs->p;

    if(Extra){
        laShowItem(uil, c, Extra, "copy_selection");
    }else{
        laShowItem(uil, c, This, "copy");
    }
    laShowItem(uil, c, This, "paste");
    laShowItem(uil, c, This, "restore");
    if(gp->Tag&LA_PROP_IS_FILE){ laShowItem(uil, c, This, "get_file_path"); }
    if(gp->Tag&LA_PROP_IS_FOLDER){ laShowItem(uil, c, This, "get_folder_path"); }
}

void laui_IdentifierOnly(laUiList *uil, laPropPack *This, laPropPack *OP_UNUSED, laColumn *Extra, int context){
    laColumn *col = Extra, *c, *cl, *cr, *crl, *crr, *cll, *clr, *clrl, *clrr, *clrrl, *clrrr;
    laUiItem *ui;

    c = laFirstColumn(uil);

    laShowItemFull(uil, c, This, "identifier", LA_WIDGET_STRING_PLAIN,0, 0, 0);
}

void laui_SubShow(laPropPack *pp){
    if (laGetInt(pp) & LA_PROP_SUB) return 1;
    return 0;
}
void laRebuildPathRecursive(laProp *p, char *buf){
    if (p->Container){
        laRebuildPathRecursive(p->Container, buf);
        sprintf(buf, ".%s", p->Identifier);
    }else
        sprintf(buf, "%s", p->Identifier);
}

void laui_IntPropInfo(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *ExtraColumns, int context){
    laColumn *col, *cl, *cr;
    laUiItem *b1,*b2;
    laUiList *tuil;

    col = laFirstColumn(uil);
    laSplitColumn(uil, col, 0.2);
    cl = laLeftColumn(col, 1);
    cr = laRightColumn(col, 0);

    laShowItemFull(uil, cr, Base, "base.identifier", LA_WIDGET_STRING_PLAIN,0, 0, 0);
    b1= laOnConditionToggle(uil, cl, 0,0,0,0,0);{
        for(laProp* p=MAIN.ContainerInt->Props.pFirst;p;p=p->Item.pNext){
            laShowItem(uil,cr,Base,p->Identifier);
        }
    }laEndCondition(uil,b1);
}
void laui_FloatPropInfo(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *ExtraColumns, int context){
    laColumn *col, *cl, *cr;
    laUiItem *b1,*b2;
    laUiList *tuil;

    col = laFirstColumn(uil);
    laSplitColumn(uil, col, 0.2);
    cl = laLeftColumn(col, 1);
    cr = laRightColumn(col, 0);

    laShowItemFull(uil, cr, Base, "base.identifier", LA_WIDGET_STRING_PLAIN,0, 0, 0);
    b1= laOnConditionToggle(uil, cl, 0,0,0,0,0);{
        for(laProp* p=MAIN.ContainerFloat->Props.pFirst;p;p=p->Item.pNext){
            laShowItem(uil,cr,Base,p->Identifier);
        }
    }laEndCondition(uil,b1);
}

void laui_SubPropInfoDefault(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laColumn *c, *cl, *cr, *cll, *clr, *crl, *crr, *crrl, *crrr;
    laUiItem *bracket, *b1, *b2;
    laPropContainer *pc;
    laProp *p;
    char buf[LA_RAW_CSTR_MAX_LEN]={0};

    c = laFirstColumn(uil);
    laSplitColumn(uil, c, 0.2);
    cl = laLeftColumn(c, 1);
    cr = laRightColumn(c, 0);
    laSplitColumn(uil, cr, 0.5);
    crrl = laLeftColumn(cr, 1*6);
    crrr = laRightColumn(cr, 0);

    laPropContainer* subc=Base->LastPs->p->SubProp;
    if (!((laSubProp*)Base->LastPs->p)->GetType){
        if (!subc) subc = la_ContainerLookup(((laSubProp *)Base->LastPs->p)->TargetID);
        if (!subc) return; Base->LastPs->p->SubProp=subc;
    }else{
        subc=((laSubProp*)Base->LastPs->p)->GetType(Base->EndInstance);
    }

    if (!Base->LastPs->p->UDFIsRefer && !Base->LastPs->p->UDFNoCreate && !Base->LastPs->p->UDFIsSingle){
        laShowItem(uil, cr, Base, "identifier")->Flags|=LA_UI_FLAGS_PLAIN;
        bracket = laOnConditionToggle(uil, cl, 0, 0, 0, 0, 0);
    }
    for (p = subc->Props.pFirst; p; p = p->Item.pNext){
        if (!(p->PropertyType & LA_PROP_SUB)){
            buf[0] = 0;
            sprintf(buf, "la.prop_containers#%s.properties#%s.name", p->Container->Identifier, p->Identifier);
            laShowItemFull(uil, crrl, 0, buf, LA_WIDGET_STRING_PLAIN,0, 0, 0);
            laShowItem(uil, crrr, Base, p->Identifier);
            //buf[0] = 0; sprintf(buf, "la.prop_containers#%s.properties#%s.name", p->Container->Identifier, p->Identifier); laShowItemFull(uil, crl, 0, buf, 0, laui_SubPropInfoDefault, 0);
            //buf[0] = 0; sprintf(buf, "la.prop_containers#%s.properties#%s.description", p->Container->Identifier, p->Identifier); laShowItemFull(uil, crr, 0, buf, 0, laui_SubPropInfoDefault, 0);
            laShowSeparator(uil, c);
        }else{
            //buf[0] = 0; sprintf(buf, "la.prop_containers#%s.properties#%s.name", p->Container->Identifier, p->Identifier); laShowItemFull(uil, crrl, 0, buf, LA_WIDGET_STRING_PLAIN, 0, 0);
            //buf[0] = 0; sprintf(buf, "la.prop_containers#%s.properties#%s.name", p->Container->Identifier, p->Identifier); laShowItemFull(uil, crl, 0, buf, 0, laui_SubPropInfoDefault, 0);
            //buf[0] = 0; sprintf(buf, "la.prop_containers#%s.properties#%s.description", p->Container->Identifier, p->Identifier); laShowItemFull(uil, crr, 0, buf, 0, laui_SubPropInfoDefault, 0);
            if (p->UDFIsRefer) laShowLabel(uil, crrr, "🠞", 0, 0);
            elif (p->UDFNoCreate) laShowLabel(uil, crrr, "n", 0, 0);
            else laShowLabel(uil, crrr, "🗇", 0, 0);

            buf[0] = 0;
            sprintf(buf, "la.prop_containers#%s.icon_id", ((laSubProp *)p)->TargetID);
            laShowIcon(uil, cl, 0, buf, 0);

            b1 = laOnConditionToggle(uil, crrl, 0, 0, 0, 0, 0);{ b1->Flags|=LA_TEXT_ALIGN_LEFT;
                sprintf(buf, "text=...%s;", p->Name);
                strSafeSet(&b1->ExtraInstructions, buf);
                laUiDefineFunc f=((laSubProp*)p)->GetType?0:
                    (p->UiDefine?p->UiDefine:(p->SubProp&&p->SubProp->UiDefine?p->SubProp->UiDefine:laui_SubPropInfoDefault));
                laShowItemFull(uil, cr, Base, p->Identifier, 0,0, f, 0);
            }
            laEndCondition(uil, b1);
            laShowSeparator(uil, c);
        }
    }
    if (!Base->LastPs->p->UDFIsRefer && !Base->LastPs->p->UDFNoCreate && !Base->LastPs->p->UDFIsSingle){
        laEndCondition(uil, bracket);
    }
    //laShowItemFull(uil, crl, Base, "identifier", 0, 0, 0);
    //p = Base->LastPs->p->SubProp->Props.pFirst;
}
void laui_SubPropSelection(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laColumn *c, *cl, *cr, *cll, *clr, *crl, *crr, *crrl, *crrr;
    laUiItem *bracket, *b1, *b2;
    laPropContainer *pc;
    laProp *p;
    laPropPack *pp;
    char buf[LA_RAW_CSTR_MAX_LEN]={0};

    c = laFirstColumn(uil);
    laSplitColumn(uil, c, 0.2);
    cl = laLeftColumn(c, 1);
    cr = laRightColumn(c, 0);
    laSplitColumn(uil, cr, 0.8);
    crl = laLeftColumn(cr, 0);
    crr = laRightColumn(cr, 100);
    laSplitColumn(uil, crl, 0.5);
    crrl = laLeftColumn(crl, 150);
    crrr = laRightColumn(crl, 0);

    if (!Base->LastPs->p->SubProp) Base->LastPs->p->SubProp = la_ContainerLookup(((laSubProp *)Base->LastPs->p)->TargetID);

    if (!Base->LastPs->p->UDFIsRefer){
        laShowItemFull(uil, cr, Base, "identifier", LA_WIDGET_STRING_PLAIN,0, 0, 0);
        bracket = laOnConditionToggle(uil, cl, 0, 0, 0, 0, 0);
    }

    for (p = Base->LastPs->p->SubProp->Props.pFirst; p; p = p->Item.pNext){
        if (p->PropertyType == LA_PROP_SUB){
            //buf[0] = 0; sprintf(buf, "la.prop_containers#%s.properties#%s.name", p->Container->Identifier, p->Identifier);
            //laShowItemFull(uil, crrl, 0, buf, LA_WIDGET_STRING_PLAIN, 0, 0);

            buf[0] = 0;
            sprintf(buf, "identifier=%s;", p->Identifier);
            laShowItemFull(uil, crrr, Base, "put_data_block", 0, buf, 0, 0);

            //laShowLabel(uil, crr, "PUT", 0, 0);
            b1 = laOnConditionToggle(uil, crrl, 0, 0, 0, 0, 0);{
                buf[0] = 0; sprintf(buf, "text=...%s;", p->Name); strSafeSet(&b1->ExtraInstructions, buf);
                laShowItemFull(uil, cr, Base, p->Identifier, 0,0, laui_SubPropSelection, 0)->Flags|=LA_TEXT_ALIGN_LEFT;
            }
            laEndCondition(uil, b1);

            laShowSeparator(uil, c);
        }
    }
    if (!Base->LastPs->p->UDFIsRefer){
        laEndCondition(uil, bracket);
    }
    //laShowItemFull(uil, crl, Base, "identifier", 0, 0, 0);
    //p = Base->LastPs->p->SubProp->Props.pFirst;
}

void laui_LinkerSelectionProp(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laColumn *c, *cl, *cr, *cll, *clr, *crl, *crr, *crrl, *crrr;
    laUiItem *bracket, *b1, *b2;
    laPropContainer *pc;
    laProp *p;
    laPropPack *pp;
    char buf[LA_RAW_CSTR_MAX_LEN]={0};

    c = laFirstColumn(uil);
    laSplitColumn(uil, c, 0.4);
    cl = laLeftColumn(c, 1);
    cr = laRightColumn(c, 0);

    b1=laBeginRow(uil,cr,0,0);
    laShowItemFull(uil, cr, Base, "identifier", LA_WIDGET_STRING_PLAIN,0, 0, 0);
    laShowIcon(uil, cr, Base, "pp.last_ps.property.sub_icon_id", 0);
    laEndRow(uil,b1);

    bracket = laOnConditionToggle(uil, cl, 0, 0, 0, 0, 0);{
        laShowItemFull(uil, cr, Base, "instances", 0,0, laui_LinkerSelectionInstance, 0);
    }
    bracket->State=LA_BT_ACTIVE;
    laEndCondition(uil, bracket);
}
void laui_LinkerSelectionInstance(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laColumn *c, *cl, *cr, *cll, *clr, *crl, *crr, *crrl, *crrr;
    laUiItem *bracket, *b1, *b2;
    laPropContainer *pc;
    laProp *p;
    laPropPack *pp;
    char buf[LA_RAW_CSTR_MAX_LEN]={0};

    c = laFirstColumn(uil);
    laSplitColumn(uil, c, 0.4);
    cl = laLeftColumn(c, 1);
    cr = laRightColumn(c, 0);

    laShowItemFull(uil, cr, Base, "identifier", LA_WIDGET_STRING_PLAIN,0, 0, 0);

    b1 = laOnConditionToggle(uil, cl, 0, 0, 0, 0, 0);{
        laShowItemFull(uil, cr, Base, "children", 0,0, laui_LinkerSelectionProp, 0);
    }
    laEndCondition(uil, b1);
}

void laui_DefaultPanelTitleBar(laUiList *uil, laPropPack *Base, laPropPack *Extra, laUiDefineFunc header){
    laColumn *c, *cl, *cr, *cll, *clr, *crl, *crr, *cb1, *cb2, *cb3;
    laUiItem *bracket, *b1, *b2;

    c = laFirstColumn(uil);
    laSplitColumn(uil, c, 0.3);
    cl = laLeftColumn(c, 1);
    cr = laRightColumn(c, 0);

    b1=laBeginRow(uil,cr,0,0);
    laShowItemFull(uil, cr, Base, "title", LA_WIDGET_STRING_PLAIN,0, 0, 0)->Expand=1;
    laShowItem(uil, cr, Base, "hide")->Flags|=LA_UI_FLAGS_ICON;
    laShowItem(uil, cr, Base, "dock")->Flags|=LA_UI_FLAGS_ICON;
    laShowItem(uil, cr, Base, "close")->Flags|=LA_UI_FLAGS_ICON;
    laEndRow(uil,b1);
    bracket = laOnConditionToggle(uil, cl, 0, 0, 0, 0, 0);{
        if(!Extra->LastPs->p->SubProp->Props.pFirst){
            laShowLabel(uil, cr, "Panel doesn't have configurable property.", 0, 0);
        }else{
            if(header){
                laShowLabel(uil, cr, "Panel properties:", 0, 0);
                header(uil, Base, Extra, cr, 0);
            }else{
                for(laProp* p = Extra->LastPs->p->SubProp->Props.pFirst;p;p=p->Item.pNext){
                    laShowItem(uil, cr, Extra, p->Identifier);
                }
            }
        }
        //laShowItem(uil, cr, 0,"la.example_int");
        laShowSeparator(uil, c);
        //laShowLabel(uil, c, "Position:", 0, 0);
        //laShowItemFull(uil, c, Base, "position", LA_WIDGET_INT, 0, 0);
        //laShowLabel(uil, c, "Size:", 0, 0);
        //laShowItemFull(uil, c, Base, "size", LA_WIDGET_INT, 0, 0);
        //laShowLabel(uil, c, "Snapping:", 0, 0);
        //laShowItem(uil, c, Base, "snap_enable")->Flags=LA_UI_FLAGS_CYCLE|LA_UI_FLAGS_TRANSPOSE;
        //laShowItemFull(uil, c, Base, "snap", LA_WIDGET_INT, 0, 0);
    }
    laEndCondition(uil, bracket);
}
void laui_DefaultOperatorPanelTitleBar(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laColumn *c, *cl, *cr, *cll, *clr, *crl, *crr;
    laUiItem *bracket, *b1, *b2;

    c = laFirstColumn(uil);

    b1 = laBeginRow(uil,c,0,0);
    laShowItemFull(uil, c, Base, "title", LA_WIDGET_STRING_PLAIN,0, 0, 0)->Expand=1;
    laShowItem(uil, c, 0, "LA_cancel");//->Flags|=LA_UI_FLAGS_ICON;
    laEndRow(uil, b1);
}

void laui_ColumnItem(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *c0, *c, *cl, *cr, *cll, *clr, *crl, *crr, *clll, *cllr, *cll2, *clr2;
    laUiItem *bracket, *b1, *b2;

    c0 = laFirstColumn(uil);
    laSplitColumn(uil, c0, 0.8);
    cll = laLeftColumn(c0, 80);
    c = laRightColumn(c0, 0);
    laSplitColumn(uil, c, 0.7);
    cl = laLeftColumn(c, 0);
    cr = laRightColumn(c, 200);
    laSplitColumn(uil, cr, 0.5);
    crl = laLeftColumn(cr, 0);
    crr = laRightColumn(cr, 70);

    laSplitColumn(uil, cll, 0.5);
    clll = laLeftColumn(cll, 1);
    cllr = laRightColumn(cll, 0);

    laSplitColumn(uil, cl, 0.5);
    cll2 = laLeftColumn(cl, 0);
    clr2 = laRightColumn(cl, 70);

    //laShowItem(uil, c, Base, "self");

    bracket = laOnConditionThat(uil, crr, laPropExpression(0, "live_editor.current_ui")); // laOnConditionThat(uil, 0, "live_editor", la_LiveEditAllowShow);
    laShowItemFull(uil, cll, Base, "select_column", 0, "text=Select;", 0, 0);
    laEndCondition(uil, bracket);

    bracket = laOnConditionThat(uil, c, laPropExpression(Base, "sub_left"));{ //laOnConditionThat(uil, Base, 0, laui_SnapButtonShow); {
        laShowItem(uil, cll2, Base, "split_at");
        laShowItemFull(uil, clr2, Base, "merge_column", 0, "text=Merge;", 0, 0);

        b1 = laOnConditionThat(uil, c, laPropExpression(Base, "snap_state"));{
            laShowItem(uil, crl, Base, "snap_width");
        }
        laElse(uil, b1);{
            laShowLabel(uil, crl, "Align:", 0, 0)->Flags|=LA_TEXT_ALIGN_RIGHT;
        }
        laEndCondition(uil, b1);

        laShowItem(uil, crr, Base, "snap_state");

        laShowSeparator(uil, c0);

        b1 = laOnConditionToggle(uil, clll, 0, 0, 0, 0, 0);{
            laShowItemFull(uil, c, Base, "sub_left", LA_WIDGET_COLLECTION_SINGLE,0, laui_ColumnItem, 0);
        }
        laElse(uil, b1);{
            laShowLabel(uil, cllr, "Left", 0, 0);
        }
        laEndCondition(uil, b1);

        laShowSeparator(uil, c0);

        b1 = laOnConditionToggle(uil, clll, 0, 0, 0, 0, 0);{
            laShowItemFull(uil, c, Base, "sub_right", LA_WIDGET_COLLECTION_SINGLE,0, laui_ColumnItem, 0);
        }
        laElse(uil, b1);{
            laShowLabel(uil, cllr, "Right", 0, 0);
        }
        laEndCondition(uil, b1);
    }
    laElse(uil, bracket);{
        laShowItem(uil, c, Base, "split_column");
    }
    laEndCondition(uil, bracket);
}

void laui_DefaultMenuBarActual(laUiList *uil, laPropPack *pp, laPropPack *actinst, laColumn *extracol, int context){
    laUiList *muil;
    laColumn *c, *c1, *c1r, *c2, *c2r, *c3, *c3r, *c4, *c4r, *mc, *mcl, *mcr;
    laUiItem* bb;

    c = laFirstColumn(uil);
    laUiItem* row=laBeginRow(uil,c,0,0);

    bb=laOnConditionThat(uil,c,laPropExpression(0,"la.windows.operator_hints"));{
        
        laShowItem(uil,c,0,"la.windows.operator_hints");

    }laElse(uil,bb);{
        laShowItem(uil, c, 0, "LA_new_panel")->Flags=LA_UI_FLAGS_ICON;
        muil = laMakeMenuPage(uil, c, "File");{
            mc = laFirstColumn(muil);
            laShowItem(muil, mc, 0, "TNS_load_exchange");

            laShowLabel(muil, mc, "Function Test", 0, 0);
            laShowItem(muil, mc, 0, "LA_pure_yes_no");
            laShowItem(muil, mc, 0, "LA_file_dialog");
            laShowItem(muil, mc, 0, "LA_udf_read");
            laShowItem(muil, mc, 0, "LA_managed_save");
            laShowItem(muil, mc, 0, "LA_manage_udf");

            laShowLabel(muil, mc, "Other Entries", 0, 0);
            laShowItemFull(muil, mc, 0, "LA_panel_activator", 0, "panel_id=LAUI_about;text=About;", 0, 0);
            laShowItem(muil, mc, 0, "LA_terminate_program");
        }
        muil = laMakeMenuPage(uil, c, "Options"); {
            mc = laFirstColumn(muil);
            laShowLabel(muil, mc, "Settings", 0, 0);
            laShowItemFull(muil, mc, 0, "LA_panel_activator", 0, "panel_id=LAUI_user_preferences;", 0, 0);
        }

        laShowSeparator(uil,c);

        laUiItem* mui=laOnConditionThat(uil,c,laPropExpression(0,"la.windows.maximized_ui"));{
            laShowItemFull(uil,c,0,"LA_canvas_ui_maximize", 0, "icon=🡰;restore=true;text=Restore Layout", 0, 0);
        }laElse(uil,mui);{
            laUiItem* ui=laOnConditionThat(uil,c,laPropExpression(0,"la.windows.maximized_block"));{
                laShowItemFull(uil,c,0,"LA_block_maximize", 0, "icon=🡰;restore=true;text=Restore Layout", 0, 0);
            }laElse(uil,ui);{
                laShowItemFull(uil, c, 0, "LA_switch_layout", 0, "icon=🞐;show_list=true;", 0, 0)->Flags|=LA_UI_FLAGS_ICON;
                laShowItemFull(uil,c,0,"LA_switch_layout", 0, "icon=🡰;reverse=true;", 0, 0)->Flags|=LA_UI_FLAGS_ICON;
                laShowItemFull(uil,c,0,"LA_switch_layout", 0, "icon=🡲;", 0,0)->Flags|=LA_UI_FLAGS_ICON;
                laShowItem(uil, c, 0, "la.windows.layouts.identifier");
                laShowItem(uil,c,0,"LA_new_window")->Flags|=LA_UI_FLAGS_ICON;
            }laEndCondition(uil, ui);
        }laEndCondition(uil,mui);

        laShowSeparator(uil,c);
        laShowLabel(uil, c, "🧩LaGUI 2022", 0, 0)->Expand=1;

        laUiItem* b1=laOnConditionThat(uil,c,laPropExpression(0,"la.windows.panels_hidden"));
            laShowSeparator(uil,c);
            muil = laMakeMenuPage(uil, c, "🡻 Minimized");{
                mc = laFirstColumn(muil);
                laShowItemFull(muil, mc, 0, "la.windows.panels_hidden", 0,0, laui_IdentifierOnly,0);
            }
        laEndCondition(uil, b1);

    }laEndCondition(uil,bb);

    laEndRow(uil,row);
}
void laui_DefaultMenuBar(laWindow *w){
    laPanel *p;
    laUiList *uil, *muil;
    laColumn *c, *c1, *c1r, *c2, *c2r, *c3, *c3r, *c4, *c4r, *mc;
    laUiItem *bracket;

    p =laCreateTopPanel(w, 0, 0, 0, 0, LA_RH, 0, 0, 0, 0, -1, -1, -1, 0);
    p->IsMenuPanel = 1;
    laui_DefaultMenuBarActual(&p->TitleBar, &p->PP, &p->PropLinkPP, 0, 0);
}

void laui_ThemeListItem(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *col, *cl, *cr;
    laUiItem *bracket;

    col = laFirstColumn(uil);

    bracket = laBeginRow(uil,col,0,0);
    laShowItemFull(uil, col, Base, "name", LA_WIDGET_STRING_PLAIN,0, 0, 0)->Expand=1;
    laShowItemFull(uil, col, Base, "author", LA_WIDGET_STRING_PLAIN,0, 0, 0);
    laEndRow(uil,bracket);
}
void laui_Theme(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *col, *cl, *cr, *cll, *clr;
    laUiItem *sui;
    laUiList *tuil;
    laUiItem *ui;

    //col = laFirstColumn(uil);
    //tuil = laMakeGroup(uil, col, "����ժҪ", 0, 0)->Page; {
    //	col = laFirstColumn(tuil);
    //	laSplitColumn(tuil, col, 0.7);
    //	cl = laLeftColumn(col, 0);
    //	cr = laRightColumn(col, 0);
    //	laSplitColumn(tuil, cr, 0.6);
    //	crl = laLeftColumn(cr, 0);
    //	crr = laRightColumn(cr, 70);
    //	laShowItemFull(tuil, cl, 0, "themes.name", 0, 0, 0);
    //	laShowItemFull(tuil, crl, 0, "themes.author", 0, 0, 0);
    //	laShowLabel(tuil, crr, 0, "EXEC", 0, 0, 0);
    //}

    col = laFirstColumn(uil); laSplitColumn(uil,col,0.5);
    cl=laLeftColumn(col,0);
    cr=laRightColumn(col,0);

    ui=laBeginRow(uil,col, 0,0);
    laShowItem(uil,col,Base, "name")->Expand=1;
    laShowItem(uil,col,Base, "delete");
    laEndRow(uil, ui);

    laShowLabel(uil, col, "Basics:",0,0);
    laShowLabel(uil, cl, "Base Color:",0,0)->Flags|=LA_TEXT_ALIGN_RIGHT; laShowItem(uil, cr, Base, "color");
    laShowLabel(uil, cl, "Accent Color:",0,0)->Flags|=LA_TEXT_ALIGN_RIGHT; laShowItem(uil, cr, Base, "accent_color");
    laShowItem(uil, cr, Base, "cursor_alpha");
    laShowItem(uil, cr, Base, "selection_alpha");
    laShowItem(uil, cr, Base, "inactive_mix");
    laShowItem(uil, cr, Base, "inactive_saturation");

    laShowLabel(uil, col, "Nodes:",0,0);
    laShowItem(uil, cr, Base, "wire_brightness");
    laShowItem(uil, cr, Base, "wire_saturation");
    laShowItem(uil, cr, Base, "wire_transparency");

    laShowLabel(uil, col, "Meshes:",0,0);
    laShowItem(uil, cl, Base, "edge_transparency");
    laShowItem(uil, cl, Base, "edge_brightness");
    laShowItem(uil, cr, Base, "vertex_transparency");
    laShowItem(uil, cr, Base, "vertex_brightness");
    laShowItem(uil, col, Base, "svertex_transparency");
    laShowItem(uil, col, Base, "sedge_transparency");
    laShowItem(uil, col, Base, "sface_transparency");    

    laShowLabel(uil, col, "Widgets:",0,0);
    laShowItem(uil, col, Base, "boxed_themes");
}
void laui_BoxedThemeItem(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *col, *cl, *cr, *crl,*crr;
    laUiItem *bracket;
    laUiList *tuil;

    col = laFirstColumn(uil);
    laSplitColumn(uil, col, 0.8);
    cl = laLeftColumn(col, 1);
    cr = laRightColumn(col, 0);
    laSplitColumn(uil, cr, 0.5);
    crl = laLeftColumn(cr, 0);
    crr = laRightColumn(cr, 0);

    laShowItemFull(uil, cr, Base, "name", LA_WIDGET_STRING_PLAIN, 0 ,0,0);

    bracket = laOnConditionToggle(uil, cl, 0, 0, 0, 0, 0);{
        laShowItem(uil, cr, Base, "normal");
        laShowItem(uil, cr, Base, "active");
        laShowItem(uil, cr, Base, "border");
        laShowItem(uil, cr, Base, "text");
        laShowItem(uil, cr, Base, "text_active");
        laShowItem(uil, cr, Base, "alpha");
        laShowLabel(uil,crl,"Margins:",0,0);
        laShowItem(uil, crl, Base, "margins")->Flags=LA_UI_FLAGS_TRANSPOSE;
        laShowLabel(uil,crr,"Paddings:",0,0);
        laShowItem(uil, crr, Base, "paddings")->Flags=LA_UI_FLAGS_TRANSPOSE;
    }
    laEndCondition(uil, bracket);
}

void laui_PropertyContainerList(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *col, *cl, *cr, *crl, *crr, *cll, *clr, *crrl, *crrr;
    laUiItem *bracket;
    laUiList *tuil;

    col = laFirstColumn(uil);
    laSplitColumn(uil, col, 0.5);
    cl = laLeftColumn(col, 60);
    cr = laRightColumn(col, 0);
    laSplitColumn(uil, cr, 0.25);
    crl = laLeftColumn(cr, 0);
    crr = laRightColumn(cr, 0);
    laSplitColumn(uil, crr, 0.3);
    crrl = laLeftColumn(crr, 0);
    crrr = laRightColumn(crr, 0);

    laShowLabel(uil, cl, "Select", 0, 0);
    laShowLabel(uil, crl, "Identifier", 0, 0);
    laShowLabel(uil, crrl, "Name", 0, 0);
    laShowLabel(uil, crrr, "Description", 0, 0);
    laShowColumnAdjuster(uil, col);

    laShowItem(uil, col, Base, "properties");
}
void laui_WindowListItem(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *col, *cl, *cr, *cll, *clr;
    laUiItem *bracket;
    laUiList *tuil;

    cl = laFirstColumn(uil);
    laSplitColumn(uil, cl, 0.2);
    cll = laLeftColumn(cl, 1);
    clr = laRightColumn(cl, 0);

    laShowItem(uil, clr, Base, "title");

    bracket = laOnConditionToggle(uil, cll, 0, 0, 0, 0, 0);{
        laShowLabel(uil, clr, "Layouts", 0, 0);
        laShowItem(uil, clr, Base, "layouts");
        laShowLabel(uil, clr, "TopPanels", 0, 0);
        laShowItem(uil, clr, Base, "panels");
    }
    laEndCondition(uil, bracket);
}
void laui_LayoutListItem(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *col, *cl, *cr, *cll, *clr;
    laUiItem *bracket;
    laUiList *tuil;

    cl = laFirstColumn(uil);
    laSplitColumn(uil, cl, 0.2);
    cll = laLeftColumn(cl, 1);
    clr = laRightColumn(cl, 0);

    laShowItem(uil, clr, Base, "title");

    bracket = laOnConditionToggle(uil, cll, 0, 0, 0, 0, 0);{
        laShowItem(uil, clr, Base, "panels");
    }
    laEndCondition(uil, bracket);
}
void laui_PanelListItem(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *col, *cl, *cr, *cll, *clr;
    laUiItem *bracket;
    laUiList *tuil;

    cl = laFirstColumn(uil);
    laSplitColumn(uil, cl, 0.2);
    cll = laLeftColumn(cl, 1);
    clr = laRightColumn(cl, 0);

    laShowItem(uil, clr, Base, "title");

    bracket = laOnConditionToggle(uil, cll, 0, 0, 0, 0, 0);{

        laShowItemFull(uil, clr, Base, "size", LA_WIDGET_INT,0, 0, 0);
    }
    laEndCondition(uil, bracket);
}
void laui_UiTemplateListItemLiveEdit(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *col, *cl, *cr, *cll, *clr;
    laUiItem *bracket;
    laUiList *tuil;

    cl = laFirstColumn(uil);

    //bracket = laOnConditionThat(uil, cl, laNot(laPropExpression(Base, "for_panel"))); {

    bracket = laOnConditionThat(uil, cl, laAnd(laNot(laPropExpression(Base, "for_panel")), laOr(laNot(laPropExpression(Base, "target")), laEqual(laPropExpression(0, "live_editor.current_ui.prop_pack.last_ps.property.sub"), laPropExpression(Base, "target")))));{
        laShowItemFull(uil, cl, Base, "identifier", LA_WIDGET_STRING_PLAIN,0, 0, 0);
    }
    laElse(uil, bracket);{
        laShowItemFull(uil, cl, Base, "identifier", LA_WIDGET_STRING_PLAIN, "disabled=true;",0, 0);
    }
    laEndCondition(uil, bracket);
}
void laui_UiTemplateListItem(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *col, *cl, *cr, *cll, *clr, *clll, *cllr, *clrl, *clrr, *clrrl, *clrrr;
    laUiItem *bracket, *b1;
    laUiList *tuil;

    cl = laFirstColumn(uil);
    laSplitColumn(uil, cl, 0.2);
    cll = laLeftColumn(cl, LA_2RH);
    clr = laRightColumn(cl, 0);

    laSplitColumn(uil, cll, 0.5);
    clll = laLeftColumn(cll, 0);
    cllr = laRightColumn(cll, 0);

    laSplitColumn(uil, clr, 0.5);
    clrl = laLeftColumn(clr, 0);
    clrr = laRightColumn(clr, 200);

    laSplitColumn(uil, clrr, 0.2);
    clrrl = laLeftColumn(clrr, 1);
    clrrr = laRightColumn(clrr, 0);

    bracket = laOnConditionThat(uil, cll, laPropExpression(Base, "define_func"));{
        laShowLabel(uil, clll, "f", 0, 0);
    }
    laEndCondition(uil, bracket);

    bracket = laOnConditionThat(uil, cll, laPropExpression(Base, "descriptor"));{
        laShowLabel(uil, cllr, "🠞", 0, 0);
    }
    laEndCondition(uil, bracket);

    laShowItemFull(uil, clrl, Base, "identifier", LA_WIDGET_STRING_PLAIN,0, 0, 0);

    bracket = laOnConditionThat(uil, cll, laPropExpression(Base, "target_id"));{
        laShowIcon(uil, clrrl, Base, "target.icon_id", 0);
        laShowItemFull(uil, clrrr, Base, "target_id", LA_WIDGET_STRING_PLAIN,0, 0, 0);
    }
    laElse(uil, bracket);{
        b1 = laOnConditionThat(uil, cll, laPropExpression(Base, "for_panel"));{
            //laShowLabel(uil, clrrl, 0,, 0, 0);
            laShowLabel(uil, clrrr, "PANEL", 0, 0);
        }
        laElse(uil, b1);{
            laShowLabel(uil, clrrr, "-", 0, LA_WIDGET_STRING_PLAIN);
        }
        laEndCondition(uil, b1);
    }
    laEndCondition(uil, bracket);
}

int la_CreateSystemWindow(laWindow *window);

void tnsui_GroupItem(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *col, *cl, *cr, *crl, *crr;
    laUiItem *b1;

    col = laFirstColumn(uil);
    laSplitColumn(uil, col, 0.3);
    cl = laLeftColumn(col, 1);
    cr = laRightColumn(col, 0);
    laSplitColumn(uil, cr, 0.5);
    crl = laLeftColumn(cr, 0);
    crr = laRightColumn(cr, 0);

    laShowItem(uil, cr, Base, "name");
    b1 = laOnConditionToggle(uil, cl, 0, 0, 0, 0, 0);{
        laShowItem(uil, cr, Base, "objects");
    }
    laEndCondition(uil, b1);
}
void tnsui_ObjectGroupItem(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *col, *cl, *cr, *crl, *crr;
    laUiItem *b1;

    col = laFirstColumn(uil);
    laSplitColumn(uil, col, 0.3);
    cl = laLeftColumn(col, 1);
    cr = laRightColumn(col, 0);
    laSplitColumn(uil, cr, 0.5);
    crl = laLeftColumn(cr, 0);
    crr = laRightColumn(cr, 0);

    laShowItem(uil, cr, Base, "group.name");
}
void tnsui_GroupObjectItem(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *col, *cl, *cr, *crl, *crr;
    laUiItem *b1;

    col = laFirstColumn(uil);
    laSplitColumn(uil, col, 0.3);
    cl = laLeftColumn(col, 1);
    cr = laRightColumn(col, 0);
    laSplitColumn(uil, cr, 0.5);
    crl = laLeftColumn(cr, 0);
    crr = laRightColumn(cr, 0);

    laShowItem(uil, cr, Base, "object.identifier");
}
void tnsui_MaterialItem(laUiList *uil, laPropPack *Base, laPropPack *UNUSED_This, laColumn *UNUSED_Colums, int context){
    laColumn *col, *cl, *cr, *crl, *crr;
    laUiItem *b1;

    col = laFirstColumn(uil);
    laSplitColumn(uil, col, 0.3);
    cl = laLeftColumn(col, 1);
    cr = laRightColumn(col, 0);
    laSplitColumn(uil, cr, 0.5);
    crl = laLeftColumn(cr, 0);
    crr = laRightColumn(cr, 0);

    laShowItem(uil, cr, Base, "object.identifier");
}

void laui_PlainSceneListItem(laUiList *uil, laPropPack *This, laPropPack *OP_UNUSED, laColumn *Extra, int context){
    laColumn *col = Extra, *c, *cl, *cr, *crl, *crr, *cll, *clr, *clrl, *clrr, *clrrl, *clrrr;
    laUiItem *ui;

    //if (Extra)c = Extra;

    c = laFirstColumn(uil);

    laShowItemFull(uil, c, This, "name", LA_WIDGET_STRING_PLAIN, 0, 0, 0);
}

void laui_DataRestorePage(laUiList *uil, laPropPack *THIS_UNUSED, laPropPack *Operator, laColumn *UNUSED, int context){
    laColumn *col = laFirstColumn(uil), *c, *cl, *cr, *crl, *crr, *cll, *clr, *clrl, *clrr, *clrrl, *clrrr;
    laUiList *u;
    laUiItem *b;

    laShowItemFull(uil, col, 0, "la", 0, 0, laui_SubPropSelection, 0);
    laShowItemFull(uil, col, 0, "tns", 0, 0, laui_SubPropSelection, 0);
}
void laui_FileBrowserFileItem(laUiList *uil, laPropPack *This, laPropPack *OP_UNUSED, laColumn *Extra, int context){
    laColumn *c = Extra, *cl, *cr, *crl, *crr, *cll, *clr, *clrl, *clrr, *clrrl, *clrrr;
    laUiItem *ui;

    laSplitColumn(0, c, 0.1);
    cll = laLeftColumn(c, 30);
    clr = laRightColumn(c, 0);
    laSplitColumn(0, clr, 0.7);
    clrl = laLeftColumn(clr, 0);
    clrr = laRightColumn(clr, 0);
    laSplitColumn(0, clrr, 0.5);
    clrrl = laLeftColumn(clrr, 0);
    clrrr = laRightColumn(clrr, 0);

    laShowItemFull(uil, cll, This, "type", LA_WIDGET_ENUM_ICON_PLAIN, 0, 0, 0)->Flags|=LA_TEXT_ALIGN_RIGHT;
    //laShowItem(uil, cll, This, "is_folder");
    laShowItemFull(uil, clrl, This, "name", LA_WIDGET_STRING_PLAIN, 0, 0, 0);
    ui = laOnConditionThat(uil, clrr, laNot(laPropExpression(This, "is_folder")));{
        laShowItemFull(uil, clrrl, This, "time_modified.time_string", LA_WIDGET_STRING_PLAIN, 0, 0, 0);
        laShowItem(uil, clrrr, This, "size")->Flags|=LA_UI_FLAGS_NO_DECAL;
    }
    laEndCondition(uil, ui);
    //laShowSeparator(uil,cll)
    //laShowItemFull(uil, clrrl, This, "time_modified.time_string", LA_WIDGET_STRING_PLAIN, 0, 0);
    //laShowItem(uil, clrrr, This, "size");
}
void laui_FileBrowserDiskItem(laUiList *uil, laPropPack *This, laPropPack *OP_UNUSED, laColumn *Extra, int context){
    laColumn *col = Extra, *c, *cl, *cr, *crl, *crr;
    laUiItem *ui;

    c = Extra;
    laSplitColumn(0, c, 0.2);
    cl = laLeftColumn(c, LA_2RH);
    cr = laRightColumn(c, 0);
    laSplitColumn(0, cr, 0.5);
    crl = laLeftColumn(cr, 0);
    crr = laRightColumn(cr, 0);
    //laShowColumnAdjuster(uil, c);

    laShowItemFull(uil, cl, This, "id", LA_WIDGET_STRING_PLAIN, 0, 0, 0);
    laShowItem(uil, crl, This, "total_gb");
    laShowItem(uil, crr, This, "free_gb");
}
void laui_FileBrowserFileList(laUiList *uil, laPropPack *THIS_UNUSED, laPropPack *Operator, laColumn *UNUSED, int context){
    laColumn *col = laFirstColumn(uil), *c, *cl, *cr, *crl, *crr, *cll, *clr, *clrl, *clrr, *clrrl, *clrrr;
    laUiList *u;
    laUiItem *b;

    laSplitColumn(uil, col, 0.25);
    cl = laLeftColumn(col, 250);
    cr = laRightColumn(col, 0);

    laShowItem(uil, cr, Operator, "path");
    laShowItemFull(uil, cl, Operator, "folder_up", LA_WIDGET_BUTTON_NO_CONFIRM, 0 ,0,0);

    u = laMakeGroup(uil, cl, "Logic Drives", 0)->Page;
    c = laFirstColumn(u);
    laSplitColumn(u, c, 0.2);
    cll = laLeftColumn(c, LA_2RH);
    clr = laRightColumn(c, 0);
    laSplitColumn(u, clr, 0.5);
    clrl = laLeftColumn(clr, 0);
    clrr = laRightColumn(clr, 0);
    laShowColumnAdjuster(u, c);
    laShowItem(u, c, Operator, "disk_list");

    b = laMakeGroup(uil, cr, "File List", 0);b->State=LA_UI_ACTIVE; u=b->Page;
    u->HeightCoeff = -3;
    c = laFirstColumn(u);
    laShowColumnAdjuster(u, c);
    laSplitColumn(u, c, 0.1);
    cll = laLeftColumn(c, 1);
    clr = laRightColumn(c, 0);
    laSplitColumn(u, clr, 0.7);
    clrl = laLeftColumn(clr, 0);
    clrr = laRightColumn(clr, 0);
    laSplitColumn(u, clrr, 0.5);
    clrrl = laLeftColumn(clrr, 0);
    clrrr = laRightColumn(clrr, 0);
    laShowLabel(u, clrl, "File Name", 0, 0);
    laShowLabel(u, clrrl, "Last Modified On", 0, 0);
    laShowLabel(u, clrrr, "File Size", 0, 0);
    laShowItem(u, c, Operator, "file_list")->Flags|=LA_UI_FLAGS_NO_DECAL;

    laShowSeparator(uil, cr);
    laUiItem*r=laBeginRow(uil,cr,0,0);
    laShowItem(uil, cr, Operator, "file_name")->Expand=1;
    b = laOnConditionThat(uil, cl, laOr(laAnd(laEqual(laPropExpression(Operator, "select_what"), laIntExpression(LA_FILE_SELECT_FILE)), laPropExpression(Operator, "file_name")), laEqual(laPropExpression(Operator, "select_what"), laIntExpression(LA_FILE_SELECT_FOLDER))));{
        laShowItem(uil, cr, 0, "LA_confirm")->Flags|=LA_UI_FLAGS_HIGHLIGHT;
    }
    laEndCondition(uil, b);
    laEndRow(uil,r);
}
void laui_LinkerPanel(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laColumn *c, *cl, *cr, *cll, *clr, *crl, *crr, *crrl, *crrr, *gc;
    laUiList *gu;
    laUiItem *bracket, *b1, *b2;
    laPropContainer *pc;
    laProp *p;
    laPropPack *pp;
    char buf[LA_RAW_CSTR_MAX_LEN]={0};

    c = laFirstColumn(uil);
    laSplitColumn(uil, c, 0.2);
    cl = laLeftColumn(c, 100);
    cr = laRightColumn(c, 0);
    laSplitColumn(uil, cr, 0.2);
    crl = laLeftColumn(cr, 1);
    crr = laRightColumn(cr, 0);

    gu = laMakeGroup(uil, c, " UDF File Content", 0)->Page;{
        gc = laFirstColumn(gu);
        laShowItem(gu, gc, OperatorInst, "root_nodes");
    }
}

void laui_ManagedUDFItem(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laColumn *c=laFirstColumn(uil);
    laSplitColumn(uil,c,0.5);
    laColumn *cl=laLeftColumn(c, 1);
    laColumn *cr=laRightColumn(c,0);
    laUiItem* b2=laOnConditionThat(uil,cr,laPropExpression(Base,"udf"));{
        laUiItem* r=laBeginRow(uil,c,0,0);
        laUiItem* b=laOnConditionToggle(uil,c,0,0,0,0,0);strSafeSet(&b->ExtraInstructions,"text=🛈;");b->Flags|=LA_UI_FLAGS_PLAIN;{
            laShowItemFull(uil,c,Base,"udf.path",LA_WIDGET_STRING_PLAIN, 0 ,0,0);
        }laElse(uil,b);{
            laShowItemFull(uil,c,Base,"basename",LA_WIDGET_STRING_PLAIN, 0 ,0,0);
        }laEndCondition(uil,b);
        laEndRow(uil, r);
    }laElse(uil,b2);{
        laShowItemFull(uil,c,Base,"basename",LA_WIDGET_STRING_PLAIN, 0 ,0,0);
    }laEndCondition(uil,b2);
}
void laui_ManagedUDFOps(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laColumn *c=laFirstColumn(uil);
    laSplitColumn(uil,c,0.3);
    laColumn *cl=laLeftColumn(c, 1);
    laColumn *cr=laRightColumn(c,0);
    laUiItem* b1=laOnConditionThat(uil, cr, laPropExpression(Base, "udf"));{
        laShowItem(uil,cl,Base,"udf.modified");
        laUiItem* b=laBeginRow(uil,cr,0,0);
        laUiItem* b2=laOnConditionToggle(uil,cr,0,0,0,0,0);strSafeSet(&b2->ExtraInstructions,"text=🛈;");b2->Flags|=LA_UI_FLAGS_PLAIN;{
            laUiItem* ui=laShowItemFull(uil,cr,Base,"udf.path",LA_WIDGET_STRING_PLAIN, 0 ,0,0);ui->Expand=1;strSafeSet(&ui->ExtraInstructions,"text=Change");
            laShowItem(uil,cr,&ui->PP,"get_file_path");
        }laElse(uil,b2);{
            laShowItemFull(uil,cr,Base,"basename", LA_WIDGET_STRING_PLAIN, 0 ,0,0)->Expand=1;
        }laEndCondition(uil,b2);
        laEndRow(uil, b);
    }laElse(uil,b1);{
        laShowItemFull(uil,cr,0,"LA_managed_save_new_file",0,"feedback=NONE;",0,0);
    }laEndCondition(uil,b1);
}
void laui_ManagedPropInstance(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    if(!Base ||! Base->EndInstance ||Base->LastPs->p->PropertyType!=LA_PROP_SUB) return;
    laColumn *c=laFirstColumn(uil);
    laSplitColumn(uil,c,0.3); laColumn *cl=laLeftColumn(c, 1); laColumn *cr=laRightColumn(c,0);
    laSplitColumn(uil,cr,0.6); laColumn *crl=laLeftColumn(cr, 30); laColumn *crr=laRightColumn(cr,0);

    laPropContainer* pc=la_EnsureSubTarget(Base->LastPs->p, Base->EndInstance);
    
    if(pc->OtherAlloc || Base->LastPs->p->UDFIsSingle){
        //laShowLabel(uil,cr,"(Item not allocated by memAcquire)",0,0)->Expand=1;
    }else{
        if(pc->Hyper==2){
            laShowItem(uil,cl,Base,"__modified"); laSplitColumn(uil,crl,0.4); laColumn *crll=laLeftColumn(crl, 0); laColumn *crlr=laRightColumn(crl,10);
            laUiItem* idui=laShowItem(uil,crll,Base,"identifier");idui->Flags|=LA_UI_FLAGS_PLAIN;idui->Expand=1;
            laShowItem(uil,crlr,Base,"__uid")->Flags|=LA_UI_FLAGS_NO_DECAL;
            if(pc->UDFPropagate){
                laColumn *crrl,*crrr,*udfc,*optionc; laSplitColumn(uil,crr,0.7); crrl=laLeftColumn(crr,0); crrr=laRightColumn(crr,1);
                laSplitColumn(uil,crrl,0.3); udfc=laLeftColumn(crrl,0); optionc=laRightColumn(crrl,8);
                laUiItem* uc=laOnConditionToggle(uil,crrr,0,0,0,0,0);{ strSafeSet(&uc->ExtraInstructions,"text=⮯;");
                    laShowItem(uil,udfc,Base,"__file");
                    laUiItem* sr=laBeginRow(uil,optionc,1,0);
                    laShowItemFull(uil,optionc,Base,"__udf_propagate",0,"force=true;text=Force;",0,0)->Flags|=LA_TEXT_ALIGN_CENTER;
                    laShowItemFull(uil,optionc,Base,"__udf_propagate",0,0,0,0)->Flags|=LA_TEXT_ALIGN_CENTER;
                    laEndRow(uil,sr);
                }laElse(uil,uc);{
                    laShowItem(uil,crrl,Base,"__file");
                }laEndCondition(uil,uc);
            }else{
                laShowItem(uil,crr,Base,"__file");
            }
        }else{
            laShowItem(uil,crl,Base,"identifier")->Flags|=LA_UI_FLAGS_PLAIN;
        }
    }
    for(laProp*p=pc->Props.pFirst;p;p=p->Item.pNext){
        if(p->PropertyType!=LA_PROP_SUB || p->UDFIsRefer) continue;
        la_EnsureSubTarget(p,0); 
        if(p->SubProp &&p->SubProp->Hyper!=2 &&(!p->UDFIsSingle)) continue;
        if(p->UDFNoCreate) continue;
        char buf[128]; sprintf(buf,"🞄 %s",p->Identifier);
        laUiItem* b=laOnConditionToggle(uil,c,0,0,0,0,0);{ strSafePrint(&b->ExtraInstructions,"text=🞄 %s;",p->Identifier);
            b->Flags|=LA_UI_FLAGS_NO_DECAL|LA_TEXT_ALIGN_LEFT; b->State=LA_BT_ACTIVE;
            laShowItemFull(uil,cr,Base,p->Identifier,0, 0,laui_ManagedPropInstance,0)->Flags|=LA_UI_FLAGS_NO_DECAL|LA_UI_COLLECTION_NO_HIGHLIGHT;
        }laEndCondition(uil,b);
    }
}
void laui_ManagedProp(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laColumn *c=laFirstColumn(uil);
    laPropPack PP={0}; if(!Base ||! Base->EndInstance) return;

    laManagedSaveProp* msp=Base->EndInstance;

    laShowLabel(uil,c,msp->Path->Ptr,0,0);
    laShowItemFull(uil,c,0,msp->Path->Ptr,0, 0,laui_ManagedPropInstance,0)->Flags|=LA_UI_FLAGS_NO_DECAL|LA_UI_COLLECTION_NO_HIGHLIGHT;
}
void laui_ManagedSavePanel(laUiList *uil, laPropPack *Base, laPropPack *Operator, laColumn *ExtraColumns, int context){
    laManagedSaveExtra*mse=Operator->EndInstance;
    laColumn *c=laFirstColumn(uil);

    if(mse->OnExit){
        laShowLabel(uil,c,"You still have unsaved/unassigned datablocks:",0,0)->Flags|=LA_TEXT_ALIGN_CENTER|LA_TEXT_LINE_WRAP;
        laShowSeparator(uil,c);
    }

    laUiItem* r=laBeginRow(uil,c,0,0);
    laShowLabel(uil,c,"Viewing",0,0);
    laShowItem(uil,c,Operator,"show_page")->Flags|=LA_UI_FLAGS_EXPAND;
    laEndRow(uil,r);
    laUiItem* g=laMakeEmptyGroup(uil,c,"List",0);{ g->State=LA_UI_ACTIVE;
        laUiList* gu=g->Page; gu->HeightCoeff=mse->OnExit?-4:-3; laColumn* gc=laFirstColumn(gu);
        laUiItem* b=laOnConditionThat(gu,gc,laEqual(laPropExpression(Operator, "show_page"),laIntExpression(0)));{
            laShowItemFull(gu,gc,0,"la.managed_props",0, 0,laui_ManagedProp,0)->Flags|=LA_UI_FLAGS_NO_DECAL|LA_UI_COLLECTION_NO_HIGHLIGHT;
        }laElse(gu,b);{
            laShowItemFull(gu,gc,0,"la.managed_udfs",0,0,0,0)->Flags|=LA_UI_FLAGS_NO_DECAL;
        }laEndCondition(gu,b);     
    }
    
    if(mse->OnExit){
        laShowLabel(uil,c,"If you exit the program now, you will lose those changes.",0,0)->Flags|=LA_TEXT_ALIGN_CENTER|LA_TEXT_LINE_WRAP;
    }

    r=laBeginRow(uil,c,0,0);
    if(mse->OnExit){
        laShowItemFull(uil,c,0,"LA_cancel",0,"text=Discard And Quit;feedback=DISCARD_AND_QUIT",0,0);
    }
    laShowSeparator(uil,c)->Expand=1;
    laShowItemFull(uil,c,0,"LA_managed_save",0,"quiet=true;ignore_unassigned=true;text=Save All Modified;feedback=SAVE_MODIFIED",0,0);
    laEndRow(uil,r);
}

void laui_ResourceFolderItem(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laColumn *c;

    c = laFirstColumn(uil);
    laUiItem* b=laBeginRow(uil,c,0,0);
    laShowItem(uil, c, Base, "remove")->Flags|=LA_UI_FLAGS_ICON;
    laUiItem* ui=laShowItem(uil, c, Base, "path");
    ui->Expand=1;
    laShowItem(uil,c,&ui->PP,"get_folder_path")->Flags|=LA_UI_FLAGS_ICON;
    laEndRow(uil,b);
}

void laui_LogItem(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laShowItem(uil, ExtraColumns, Base, "content")->Flags|=LA_TEXT_LINE_WRAP|LA_TEXT_USE_NEWLINE|LA_TEXT_MONO;
}


void laui_UserPreference(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laColumn* c = laFirstColumn(uil);
    laUiList *muil;
    laColumn *mc, *mcl, *mcr, *mcll, *mclr;
    laUiItem *b, *bracket;

    //_LA_PANEL_USER_PREFERENCE = p;
    //la_UDFAppendSharedTypePointer("_LA_PANEL_USER_PREFERENCE", _LA_PANEL_USER_PREFERENCE);
    //p->Show = 0;
    //p->FastUpdate = 1;

    bracket = laMakeTab(uil, c, 0);{
        muil = laAddTabPage(bracket, "Display");{
            //muil->HeightCoeff = -1;
            mc = laFirstColumn(muil);
            laSplitColumn(muil, mc, 0.5);
            mcl = laLeftColumn(mc, 0);
            mcr = laRightColumn(mc, 0);

            laShowLabel(muil, mc, "Interface:", 0, 0);
            laShowLabel(muil, mcl, "Row Height:", 0, 0);
            laShowItem(muil, mcr, 0, "la.user_preferences.interface_size");
            laShowLabel(muil, mcl, "Font Size:", 0, 0);
            laShowItem(muil, mcr, 0, "la.user_preferences.font_size");
            laShowLabel(muil, mcl, "Margin Size:", 0, 0);
            laShowItem(muil, mcr, 0, "la.user_preferences.margin_size");
            laShowLabel(muil, mcl, "Panel Multisample:", 0, 0);
            laShowItem(muil, mcr, 0, "la.user_preferences.panel_multisample")->Flags|=LA_UI_FLAGS_EXPAND;
            laShowItem(muil, mc, 0, "la.user_preferences.top_framerate");

            laShowSeparator(muil, mc);

            laShowLabel(muil, mc, "Nodes:", 0, 0);
            laShowItem(muil, mcr, 0, "la.user_preferences.wire_color_slices");
            laShowItem(muil, mcr, 0, "la.user_preferences.wire_thickness");
            laShowItem(muil, mcr, 0, "la.user_preferences.wire_saggyness");

            laShowSeparator(muil, mc);

            laShowLabel(muil, mc, "Floating Panel:", 0, 0);
            laShowItem(muil, mcl, 0, "la.user_preferences.floating_alpha");
            laShowItem(muil, mcr, 0, "la.user_preferences.solid_shadow_length");

            laShowSeparator(muil, mc);

            laShowLabel(muil, mc, "Translation:", 0, 0);
            laShowLabel(muil, mcl, "Enable Translation:", 0, 0);
            laShowItem(muil, mcr, 0, "la.user_preferences.enable_translation");
            b = laOnConditionThat(muil, mcl, laPropExpression(0, "la.user_preferences.enable_translation"));{
            laShowLabel(muil, mcl, "Language:", 0, 0);
                laShowItemFull(muil, mcr, 0, "la.user_preferences.languages", LA_WIDGET_COLLECTION_SELECTOR, 0, 0, 0);
                laShowItem(muil, mcl, 0, "LA_translation_dump");
            }
            laEndCondition(muil, b);
        }
        
        muil = laAddTabPage(bracket, "Input");{
            //muil->HeightCoeff = -1;
            mc = laFirstColumn(muil);
            laSplitColumn(muil, mc, 0.5);
            mcl = laLeftColumn(mc, 0);
            mcr = laRightColumn(mc, 0);

            laShowLabel(muil, mc, "User Interactions:", 0, 0);
            laShowItem(muil, mc, 0, "la.user_preferences.scroll_speed");
            laShowItem(muil, mcl, 0, "la.user_preferences.animation_speed");
            laShowItem(muil, mcr, 0, "la.user_preferences.panel_animation_speed");
            laShowItem(muil, mc, 0, "la.user_preferences.valuator_threshold");
            laShowItem(muil, mc, 0, "la.user_preferences.zoom_speed_2d");
            laShowItem(muil, mcl, 0, "la.user_preferences.tooltip_close_distance");
            laShowItem(muil, mcr, 0, "la.user_preferences.idle_time");
        }

        muil = laAddTabPage(bracket, "Resource");{
            //muil->HeightCoeff = -1;
            mc = laFirstColumn(muil);

            laSplitColumn(muil, mc, 0.5);
            mcl = laLeftColumn(mc, 0);
            mcr = laRightColumn(mc, 0);
            laShowLabel(muil, mcl, "UDF Manager Default View:", 0, 0);
            laShowItem(muil, mcr, 0, "la.user_preferences.manager_default_view")->Flags|=LA_UI_FLAGS_EXPAND;

            laShowSeparator(muil,mc);

            b=laBeginRow(muil,mc,0,0);
            laShowLabel(muil, mc, "Resource Folders", 0, 0)->Expand=1;
            laShowItem(muil, mc, 0, "LA_add_resource_folder");
            laEndRow(muil,b);
            laShowItem(muil, mc, 0, "la.user_preferences.resource_folders");
        }

        muil = laAddTabPage(bracket, "Theme");{
            //muil->HeightCoeff = -1;
            mc = laFirstColumn(muil);
            laShowLabel(muil, mc, "Active Theme", 0, 0);
            laShowItemFull(muil, mc, 0, "la.themes", LA_WIDGET_COLLECTION_SELECTOR, 0,laui_ThemeListItem,0);
            laShowItemFull(muil, mc, 0, "la.themes", LA_WIDGET_COLLECTION_SINGLE, 0 ,0,0);
        }
    }
}
void laui_About(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laColumn *c, *cl, *cr, *tc, *gc, *gcl, *gcr, *tcl, *tcr;
    laUiItem *bracket, *t, *g;
    laPanel *p;
    laUiList *u, *gu;
    laPropContainer *pc;
    int h;
    laOperatorType *at;
    laUiList *first;
    char buf[2048]={0};

    c = laFirstColumn(uil);

    laShowLabel(uil, c, "LaGUI", 0, 0);
    laShowLabel(uil, c, "2022", 0, 0);
    laShowLabel(uil, c, "(C)Yiming Wu", 0, 0);

    t = laMakeTab(uil, c, 0);{
        first = u = laAddTabPage(t, "Version");
        u->HeightCoeff=-1;
        tc = laFirstColumn(u);

        g = laMakeGroup(u, tc, "User Interface", 0);
        gu = g->Page;{
            gc = laFirstColumn(gu);

            //laShowSymbol(gu, gc, 0, 0);
            laShowSymbol(gu, gc, 0, 0);
            laShowLabel(gu, gc, "A graphical user interface application toolkit", 0, 0)->Flags|=LA_TEXT_LINE_WRAP;;
            laShowLabel(gu, gc, "(C)YimingWu", 0, 0);

            sprintf(buf, "🛈 LA.%d.%d.%d", LA_VERSION_MAIN, LA_VERSION_SUB, LA_VERSION_MINOR);
            laShowLabelDynamic(gu, gc, buf, 0, 0);
            laShowLabel(gu, gc, "🗇" " Branch:master", 0, 0);
            sprintf(buf, "📅 Date:[UTC+8] %s %s", __DATE__, __TIME__);
            laShowLabelDynamic(gu, gc, buf, 0, 0);
            sprintf(buf, "🖹 UDF Capability %d.%d.%d", LA_UDF_CAPABILITY_MAIN, LA_UDF_CAPABILITY_SUB, LA_UDF_CAPABILITY_MINOR);
            laShowLabelDynamic(gu, gc, buf, 0, 0);
        }
        
        g = laMakeGroup(u, tc, "Graphics Information", 0);
        gu = g->Page;{
            gc = laFirstColumn(gu);
            laSplitColumn(gu, gc, 0.6);
            gcl = laLeftColumn(gc, 0);
            gcr = laRightColumn(gc, 0);
            laShowSymbol(gu, gcl, 0, 0);

            laShowLabel(gu, gc, "The interface uses OpenGL as the graphics backend", 0, 0)->Flags|=LA_TEXT_LINE_WRAP;

            sprintf(buf, "🛈" " OpenGL Version: %s", T->GLVersionStr);
            laShowLabelDynamic(gu, gc, buf, 0, 0);
            sprintf(buf, "🛈" " OpenGL Vendor: %s", T->GLVendorStr);
            laShowLabelDynamic(gu, gc, buf, 0, 0);
            sprintf(buf, "🛈" " OpenGL Renderer: %s", T->GLRendererStr);
            laShowLabelDynamic(gu, gc, buf, 0, 0);
            sprintf(buf, "🛈" " GLSL Version: %s", T->GLSLVersionStr);
            laShowLabelDynamic(gu, gc, buf, 0, 0);
        }

        g = laMakeGroup(u, tc, "Build Tool", 0);
        gu = g->Page;{
            gc = laFirstColumn(gu);
            laShowSymbol(gu, gc, 0, 0);
            laShowLabel(gu, gc, "This Program Is Built With GCC Tool Chain", 0, 0)->Flags|=LA_TEXT_LINE_WRAP;
        }

        u = laAddTabPage(t, "Props");{
            c = laFirstColumn(u);
            laSplitColumn(u, c, 0.2);
            gcl = laLeftColumn(c, 1);
            gcr = laRightColumn(c, 0);
            for (pc = MAIN.PropContainers.pFirst; pc; pc = pc->Item.pNext){
                buf[0] = L' ';buf[1]= L'\0';
                if(pc->IconID){
                    sprintf(buf, "%lc", pc->IconID);
                }
                laShowLabelDynamic(u, gcl, buf, 0, LA_WIDGET_STRING_PLAIN);
                laShowLabelDynamic(u, gcr, pc->Identifier, 0, LA_WIDGET_STRING_PLAIN);
            }
        }

        u = laAddTabPage(t, "Functions");{
            c = laFirstColumn(u);
            laSplitColumn(u, c, 0.2);
            gcl = laLeftColumn(c, 1);
            gcr = laRightColumn(c, 0);
            for (h = 0; h < 256; h++){
                for (at = MAIN.OperatorTypeHash.Entries[h].pFirst; at; at = at->Item.pNext){
                    buf[0] = L' ';buf[1]= L'\0';
                    if(at->IconID){
                        sprintf(buf, "%lc", at->IconID);
                    }
                    laShowLabelDynamic(u, gcl, buf, 0, LA_WIDGET_STRING_PLAIN);
                    laShowLabelDynamic(u, gcr, at->Identifier, 0, LA_WIDGET_STRING_PLAIN);
                }
            }
        }

        u = laAddTabPage(t, "Contact");
        tc = laFirstColumn(u);
        laSplitColumn(u, tc, 0.8);
        tcl = laLeftColumn(tc, 60);
        tcr = laRightColumn(tc, 00);

        strSafeSet(&laShowSymbol(u, tc, 0, 0)->ExtraInstructions, "mode=invert;preserve=5;");

        laShowItemFull(u, tcl, 0, "LA_open_internet_link", 0, "link=http://www.wellobserve.com;", 0, 0);
        laShowLabel(u, tcr, "Yiming's Website", 0, 0);
        laShowSeparator(u, tc);

        laShowLabel(u, tcr, "QQ 1094469528", 0, 0);
        laShowSeparator(u, tc);

        laShowItemFull(u, tcl, 0, "LA_open_internet_link", 0, "link=http://weibo.com/1919404360;", 0, 0);
        laShowLabel(u, tcr, "Weibo", 0, 0);

        laShowItemFull(u, tcl, 0, "LA_open_internet_link", 0, "link=https://www.artstation.com/artist/nicksbest;", 0, 0);
        laShowLabel(u, tcr, "Artstation", 0, 0);

        laShowItemFull(u, tcl, 0, "LA_open_internet_link", 0, "link=mailto:1094469528@qq.com;icon=🖅", 0, 0);
        laShowLabel(u, tcr, "QQ Mail", 0, 0);

        laShowLabel(u, tcr, "Outlook Mail", 0, 0);
        laShowItemFull(u, tcl, 0, "LA_open_internet_link", 0, "link=mailto:xp8110@outlook.com;icon=🖅", 0, 0);

        t->Page = first;
    }
}
void laui_terminal(laUiList *uil, laPropPack *Base, laPropPack *OperatorInst, laColumn *ExtraColumns, int context){
    laColumn* c=laFirstColumn(uil);
    laUiItem* g=laMakeGroup(uil,c,"123",0);{ g->State=LA_UI_ACTIVE; g->Flags|=LA_UI_FLAGS_PREFER_BOTTOM;
        laUiList* gu=g->Page; laColumn* gc=laFirstColumn(gu); gu->HeightCoeff=-1;
        laShowItem(gu,gc,0,"la.logs")->Flags|=LA_UI_FLAGS_NO_DECAL;
    }
}
void laui_IdleDataManager(laUiList *uil, laPropPack *Base, laPropPack *Extra, laColumn *ExtraColumns, int context){
    laColumn *c=laFirstColumn(uil);

    laUiItem* r=laBeginRow(uil,c,0,0);
    laShowLabel(uil,c,"Viewing",0,0);
    laShowItem(uil,c,Extra,"show_page")->Flags|=LA_UI_FLAGS_EXPAND;
    laEndRow(uil,r);
    laUiItem* g=laMakeEmptyGroup(uil,c,"List",0);{ g->State=LA_UI_ACTIVE;
        laUiList* gu=g->Page; gu->HeightCoeff=-3; laColumn* gc=laFirstColumn(gu);
        laUiItem* b=laOnConditionThat(gu,gc,laEqual(laPropExpression(Extra, "show_page"),laIntExpression(0)));{
            laShowItemFull(gu,gc,0,"la.managed_props",0, 0,laui_ManagedProp,0)->Flags|=LA_UI_FLAGS_NO_DECAL;
        }laElse(gu,b);{
            laShowItemFull(gu,gc,0,"la.managed_udfs",0,0,0,0)->Flags|=LA_UI_FLAGS_NO_DECAL;
        }laEndCondition(gu,b);     
    }
    
    r=laBeginRow(uil,c,0,0);
    laShowSeparator(uil,c)->Expand=1;
    laShowItemFull(uil,c,0,"LA_managed_save",0,"quiet=true;ignore_unassigned=true;text=Save All Modified",0,0);
    laEndRow(uil,r);
}
void lauidetached_IdleDataManager(laPanel* p){
    la_MakeDetachedProp(p, "la.user_preferences.manager_default_view", "show_page");
}
void laui_TextureInspector(laUiList *uil, laPropPack *Base, laPropPack *Extra, laColumn *ExtraColumns, int context){
    laColumn *c=laFirstColumn(uil),*cl,*cr;
    laSplitColumn(0, c, 0.5);
    cl = laLeftColumn(c, 0);
    cr = laRightColumn(c, 0);

    laShowLabel(uil,cl,"Viewing Texture:",0,0)->Flags|=LA_TEXT_ALIGN_RIGHT;
    laShowItemFull(uil,cr,Extra,"textures",LA_WIDGET_COLLECTION_SELECTOR,0,0,0);
    laUiItem* u2=laShowCanvas(uil,c,Extra,"textures",0,-1);
    laDefault2DViewOverlayRight(u2);
}
void lauidetached_TextureInspector(laPanel* p){
    la_MakeDetachedProp(p, "tns.texture_list", "textures");
}
void laui_GameController(laUiList *uil, laPropPack *This, laPropPack *Extra, laColumn *UNUSED, int context){
    laColumn* c=laFirstColumn(uil),*cl, *cr;
    laSplitColumn(uil,c,0.5); cl=laLeftColumn(c,0); cr=laRightColumn(c,0);
    laShowLabel(uil,cl,"Controller:",0,0)->Flags|=LA_TEXT_ALIGN_RIGHT;
    laShowItemFull(uil,cr,Extra,"controllers",LA_WIDGET_COLLECTION_SELECTOR,0,laui_IdentifierOnly,0);
    laShowItemFull(uil,c,Extra,"controllers",LA_WIDGET_COLLECTION_SINGLE,0,0,0);
}
void lauidetached_GameController(laPanel* p){
    la_MakeDetachedProp(p, "la.controllers", "controllers");
}


void la_RegisterBuiltinTemplates(){
    //laRegisterUiTemplate("LAUI_default_subwindow_menubar", "Menu", laui_DefaultSubWindowMenuBarActual, 0);
    //laRegisterUiTemplate("LAUI_default_menubar", "Menu", laui_DefaultMenuBarActual, 0);
    laRegisterUiTemplate("LAUI_user_preferences", "User Preferences", laui_UserPreference, 0, 0);
    laRegisterUiTemplate("LAUI_about", "About", laui_About, 0, 0);
    laRegisterUiTemplate("LAUI_texture_inspector", "Texture Inspector", laui_TextureInspector, lauidetached_TextureInspector, 0);
    laRegisterUiTemplate("LAUI_data_manager", "Data Manager", laui_IdleDataManager, lauidetached_IdleDataManager, 0);
    laRegisterUiTemplate("LAUI_terminal", "Terminal", laui_terminal, 0, 0);
    laRegisterUiTemplate("LAUI_controllers", "Controllers", laui_GameController, lauidetached_GameController, 0);
}
